// DS102Dlg.cpp : Cve[V t@C
//
//
//------------------------------------------------------------
//
//  DS102/DS112Rg[pTvvO(Ver.1.00)
//
//   ̃TvvOMicroSoftЂ񋟂
//   MSCommRg[gpĂ܂B
//  RS-232CP[u͕Ўw̃NXP[ugpB
//
//------------------------------------------------------------

#include "stdafx.h"
#include "DS102.h"
#include "DS102Dlg.h"
#include "SetupDlg.h"
#include "CommDlg.h"
#include <comdef.h>
#include <math.h>

#define LIMIT_TIME  2.0

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS102Dlg _CAO

CDS102Dlg::CDS102Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDS102Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDS102Dlg)
	m_dPosition1 = 0.0;
	m_dPosition2 = 0.0;
	m_uiSpeed1 = 1000;
	m_uiSpeed2 = 1000;
	m_dStep1 = 0.0;
	m_dStep2 = 0.0;
	m_strUnit1 = _T("");
	m_strUnit2 = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDS102Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDS102Dlg)
	DDX_Control(pDX, IDC_CW2, m_btnCW2);
	DDX_Control(pDX, IDC_CW1, m_btnCW1);
	DDX_Control(pDX, IDC_CCW2, m_btnCCW2);
	DDX_Control(pDX, IDC_CCW1, m_btnCCW1);
	DDX_Control(pDX, IDC_MSCOMM1, m_MSComm);
	DDX_Text(pDX, IDC_POSITION1, m_dPosition1);
	DDX_Text(pDX, IDC_POSITION2, m_dPosition2);
	DDX_Text(pDX, IDC_SPEED1, m_uiSpeed1);
	DDX_Text(pDX, IDC_SPEED2, m_uiSpeed2);
	DDX_Text(pDX, IDC_STEP1, m_dStep1);
	DDV_MinMaxDouble(pDX, m_dStep1, -99999999., 99999999.);
	DDX_Text(pDX, IDC_STEP2, m_dStep2);
	DDV_MinMaxDouble(pDX, m_dStep2, -99999999., 99999999.);
	DDX_Text(pDX, IDC_UNIT1, m_strUnit1);
	DDX_Text(pDX, IDC_UNIT2, m_strUnit2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDS102Dlg, CDialog)
	//{{AFX_MSG_MAP(CDS102Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONT, OnCont)
	ON_BN_CLICKED(IDC_STEP, OnStep)
	ON_BN_CLICKED(IDC_POINT, OnPoint)
	ON_BN_CLICKED(IDC_ORG, OnOrg)
	ON_COMMAND(IDC_MENU_AXIS1, OnMenuAxis1)
	ON_COMMAND(IDC_MENU_AXIS2, OnMenuAxis2)
	ON_BN_CLICKED(IDC_EMG, OnEmg)
	ON_BN_CLICKED(IDC_CLEAR1, OnClear1)
	ON_BN_CLICKED(IDC_CLEAR2, OnClear2)
	ON_WM_TIMER()
	ON_COMMAND(IDC_END, OnEnd)
	ON_COMMAND(IDC_MENU_COMM, OnMenuComm)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MY_LBUTTON_DOWN,OnDown)
	ON_MESSAGE(WM_MY_LBUTTON_UP,OnUp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS102Dlg bZ[W nh

BOOL CDS102Dlg::OnInitDialog()
{
	m_btnCW1.SubclassDlgItem(IDC_CW1,this);
	m_btnCW2.SubclassDlgItem(IDC_CW2,this);
	m_btnCCW1.SubclassDlgItem(IDC_CCW1,this);
	m_btnCCW2.SubclassDlgItem(IDC_CCW2,this);

	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	// ϐ̏
	iMoveStyle = 0;
	nTimerID = 1;
	iTimer = 0;

	// Rg[̏
	((CButton*)GetDlgItem(IDC_CONT))->SetCheck(1);

	OnEmg();
	SetUnit(1);
	SetUnit(2);
	GetPosition(1);
	GetPosition(2);
	GetStatus3(1);
	GetStatus3(2);
	GetStatus1(1);
	GetStatus1(2);
	GetStatus2(1);
	GetStatus2(2);
	GetFSpeed(1);
	GetFSpeed(2);

	UpdateStatus();
	UpdateData(FALSE);
	
	//
	// Comm|[g̏s
	//
	iCommPort = 1;
	SetCommPort(iCommPort);

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CDS102Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CDS102Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CDS102Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDS102Dlg::OnOK() 
{

	//CDialog::OnOK();	// ReturnL[ɂI邽߁AOnOK()폜
}

void CDS102Dlg::OnCancel() 
{
	// I{^ꂽꍇ
	Send("STOP 0");
	if( MessageBox("I܂B낵łH","ImF",MB_OKCANCEL) == IDOK){
		if (m_MSComm.GetPortOpen() == TRUE)
			m_MSComm.SetPortOpen(FALSE);
		CDialog::OnCancel();
	}
}

void CDS102Dlg::OnCont() 
{
// Aړ[h
	iMoveStyle = 0;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("i{j");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("i{j");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText("i|j");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText("i|j");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(FALSE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(FALSE);
}

void CDS102Dlg::OnStep() 
{
// Xebvړ[h	
	iMoveStyle = 1;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("i{j");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("i{j");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText("i|j");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText("i|j");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->SetWindowText("ړ");
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->SetWindowText("ړ");
}

void CDS102Dlg::OnPoint() 
{
// wʒuړ[h	
	iMoveStyle = 2;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("wʒu");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("wʒu");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText("Oʒu");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText("Oʒu");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->SetWindowText("ړʒu");
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->SetWindowText("ړʒu");
}

void CDS102Dlg::OnOrg() 
{
// _A[h	
	iMoveStyle = 3;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("_A");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("_A");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText("_A");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText("_A");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(FALSE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(FALSE);
}

void CDS102Dlg::OnMenuComm() 
{
//
// ʐM̃ZbgAbv
//
	CCommDlg clsCommDlg;
	clsCommDlg.iPort = iCommPort;
	if (IDOK == clsCommDlg.DoModal()){
		iCommPort = clsCommDlg.iPort;
	}
	Sleep(400);
	CommInit();
	SetUnit(1);
	SetUnit(2);
	UpdateData(FALSE);
	UpdateStatus();
	
}

void CDS102Dlg::OnMenuAxis1() 
{
//
// 1̃ZbgAbv
//
	CSetupDlg clsSetup;
	clsSetup.iAxisNumber = 1;
	clsSetup.DoModal();
	Sleep(400);
	CommInit();
	SetUnit(1);
	UpdateData(FALSE);
	UpdateStatus();
}

void CDS102Dlg::OnMenuAxis2() 
{
//
// Q̃ZbgAbv
//
	CSetupDlg clsSetup;
	clsSetup.iAxisNumber = 2;
	clsSetup.DoModal();
	Sleep(400);
	CommInit();
	SetUnit(2);
	UpdateStatus();
}

void CDS102Dlg::OnDown(WPARAM wParam,LPARAM lParam){
//
// ړ{^ꂽꍇ
// 
	if (UpdateData(TRUE) == FALSE) return;
	int iAxis;								// ԍ
	int iMoveDirection;						// ړ
	CString strCommand;						// R}hMpobt@

	// wParamAԍƈړ𓾂
	if(wParam == IDC_CW1) {iAxis = 1;iMoveDirection = 5;}
	if(wParam == IDC_CW2) {iAxis = 2;iMoveDirection = 5;}
	if(wParam == IDC_CCW1){iAxis = 1;iMoveDirection = 6;}
	if(wParam == IDC_CCW2){iAxis = 2;iMoveDirection = 6;}

	// 쓮xiej`FbN
	if(m_uiSpeed1<1 || m_uiSpeed1>999999){
		MessageBox("쓮xsł");
		return;
	}
	if(m_uiSpeed2<1 || m_uiSpeed2>999999){
		MessageBox("쓮xsł");
		return;
	}

	// 쓮xiejXV
	switch(iAxis){
	case 1:
		iFSpeed[0] = m_uiSpeed1;
	case 2:
		iFSpeed[1] = m_uiSpeed2;
	}

	// I𒆂̈ړ@ɂA{^ꍇ̏U蕪
	switch(iMoveStyle){
	case 0:
	// ړ@Aړ[h
		if (iTimer & iAxis) break;									// ݁A̎쒆Ȃ牽Ȃ
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// 쓮xݒ肷R}hZbg
		Send(strCommand);
		strCommand.Format("Axi%d:Selsp %d:go %d", iAxis, iAxis, iMoveDirection);	// ړR}hZbg
		Send(strCommand);
		if (iTimer == 0)
			SetTimer(nTimerID,50,NULL);				// ^C}o^ĂȂꍇA^C}o^
		iTimer = iTimer | int(pow(2, iAxis-1));						// iTimeŕAԍɑΉrbgnmɂ
		break;
	case 1:
	case 2:
	case 3:
	// ړ@̑̏ꍇA{^𗣂ƂɓJn̂ŉȂ
		break;
	}
}

void CDS102Dlg::OnUp(WPARAM wParam,LPARAM lParam){
//
// ړ{^ꂽꍇ
//
	int iAxis;			// ԍ
	int iMoveDirection;	// ړ
	CString strCommand;
	double dPosition;

	// ԍAړшړʒu𓾂
	if(wParam == IDC_CW1) {iAxis = 1;iMoveDirection = 0;dPosition = m_dStep1;}
	if(wParam == IDC_CW2) {iAxis = 2;iMoveDirection = 0;dPosition = m_dStep2;}
	if(wParam == IDC_CCW1){iAxis = 1;iMoveDirection = 1;dPosition = m_dStep1;}
	if(wParam == IDC_CCW2){iAxis = 2;iMoveDirection = 1;dPosition = m_dStep2;}

	// I𒆂̈ړ@ɂA{^𗣂ꍇ̏U蕪
	switch(iMoveStyle){
	case 0:
	// ړ@Aړ[h
		strCommand.Format("axi%d:stop 0",iAxis);	// ~R}hZbg
		Send(strCommand);							// R}h𑗐M
		CheckStop(iAxis);							// ~܂ő҂
		OnTimer(0);									// WƃXe[^XXV

		// SĂ̎~ĂꍇA^C}Xgbv
		if (iTimer == 0) {
			KillTimer(nTimerID);
		}
		break;

	case 1:
	// ړ@Xebvړ[h
		if (iTimer & iAxis) break;									// ݁A̎쒆Ȃ牽Ȃ
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// xύXR}hZbg
		Send(strCommand);
		strCommand.Format("Axi%d:Selsp %d:PULSE %g:go %d", iAxis, iAxis, dPosition,iMoveDirection);	// ړsR}hZbg
		Send(strCommand);
		if (iTimer == 0)  SetTimer(nTimerID,50,NULL);				// ^C}o^ĂȂꍇ̓^C}o^
		iTimer = iTimer | int(pow(2 ,iAxis-1));						// iTimeŕAɑΉrbgnmɂ
		break;

	case 2:
	// ړ@wʒuړ[h
		if (iTimer & iAxis) break;									// ݁A̎쒆Ȃ牽Ȃ
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// xύXR}hZbg
		Send(strCommand);
		if (iMoveDirection == 1) dPosition = 0.;					// CCW{^ꍇAړʒuOɂ
		strCommand.Format("Axi%d:Selsp %d:goabs %g", iAxis, iAxis, dPosition);	// ΈʒuړR}hZbg
		Send(strCommand);
		if (iTimer == 0)  SetTimer(nTimerID,50,NULL);				// ^C}o^ĂȂꍇ̓^C}o^
		iTimer = iTimer | int(pow(2,iAxis-1));						// iTimeŕAɑΉrbgnmɂ
		break;
		
	case 3:
	// ړ@_A[h
		if (iTimer & iAxis) break;									// ݁A̎쒆Ȃ牽Ȃ
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// xύXR}hZbg
		Send(strCommand);
		strCommand.Format("Axi%d:Selsp %d:go org", iAxis, iAxis);	// _AsR}hZbg
		Send(strCommand);
		if (iTimer == 0)  SetTimer(nTimerID,50,NULL);				// ^C}o^ĂȂꍇ̓^C}o^
		iTimer = iTimer | int(pow(2,iAxis-1));						// iTimeŕAɑΉrbgnmɂ
		break;
	}
}

BOOL CDS102Dlg::Send(CString strMessage){
//
// Comm|[gɕ𑗐M
//
	_variant_t vCommand;								// MSCommp̑Mobt@
	
	vCommand.SetString(strMessage+"\r");				// oAg^ɑMR}hZbg
	if (m_MSComm.GetPortOpen() == FALSE) return FALSE;	// Comm|[g̏ςłȂ΃G[I
	m_MSComm.SetOutput(vCommand);						// MComm|[gɑ
	return TRUE;
}

BOOL CDS102Dlg::Receive(CString& strMessage){
//
// Comm|[g當M
//
	time_t tStart;			// MJn
	time_t tNow;			// 
	_variant_t	vReceive;	// oAg^̎Mobt@

	strMessage = "";		// M
	time(&tStart);			// MJn𓾂
	do{
		if (m_MSComm.GetInBufferCount() > 0){		// Comm|[g̃obt@ɕԓbZ[W܂𒲂ׂ
			vReceive = m_MSComm.GetInput();			// Comm|[g̃obt@ǂݍ
			strMessage += V_BSTR(&vReceive);		// oAg^CString^ɕϊAȑO܂ł̎Mf[^ƘA
			if (strMessage.Right(1) == "\r"){		// f~^܂łM𒲂ׂ
				return TRUE;
			}
		}
		time (&tNow);								// 𓾂
	}while(difftime(tNow, tStart) < LIMIT_TIME);	// |MJn~bgz烋[v𔲂
	return FALSE;									// ^CI[oŔ߁AFALSEԂ
}

BOOL CDS102Dlg::SetCommPort(int iPort){
//
// RS-232C|[gݒ肷
//
	if (m_MSComm.GetPortOpen() == TRUE){
		m_MSComm.SetPortOpen(FALSE);
	}
	m_MSComm.SetCommPort(iPort);
	m_MSComm.SetRTSEnable(iPort);
	m_MSComm.SetPortOpen(iPort);
	CString strIDN;
	CString strMsg;

	//
	// IDNNG𑗐MAڑĂRg[
	// DS102/DS112Rg[ł邩𒲂ׂ
	//
	if (Send("*IDN?") == FALSE){
		MessageBox("RS232C̒ʐMɎs܂");
		return FALSE;
	}
	if (Receive(strIDN) == FALSE){
		strMsg.Format("Rg[|[g%dɐڑĂ܂B\r܂̓P[uzႢ܂", iPort);
		MessageBox(strMsg);
		return FALSE;
	}
	if (strIDN.Mid(0,10) !="SURUGA,DS1"){
		strMsg.Format("|[g%dDS102/DS112Rg[ȊŐ@킪ڑĂ܂", iPort);
		MessageBox(strMsg);
		return FALSE;
	}

	if (CommInit() == FALSE){
		MessageBox("ʐMɈُ킪܂");
		return FALSE;
	}
	iCommPort = iPort;
	return TRUE;
}	

BOOL CDS102Dlg::CommInit(){
//
// ʐMFRg[쓮p[^M
//
	CString strMessage;
	if (Send("axi1:selsp 1") == FALSE) return FALSE;		// Axis1̃Xs[he[uPɐݒ肷
	if (Send("axi2:selsp 2") == FALSE) return FALSE;		// Axis2̃Xs[he[uQɐݒ肷

	// Uniti\Pʁj𓾂
	if (Send("axi1:unit?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	iUnit[0] = atoi(strMessage);
	if (Send("axi2:unit?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	iUnit[1] = atoi(strMessage);

	// W𓾂
	if (Send("axi1:position?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	m_dPosition1=atof(strMessage);
	if (Send("axi2:position?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	m_dPosition2 = atof(strMessage);

	// hCoXe[^X𓾂
	GetStatus1(1);
	GetStatus2(1);
	GetStatus3(1);
	GetStatus1(2);
	GetStatus2(2);
	GetStatus3(2);
	
	return TRUE;
}	

void CDS102Dlg::SetUnit(int iAxisNumber){
//
// jbgύX
//

	CString strCaption;

	switch(iUnit[iAxisNumber-1]){
	case 0:
		strCaption = "PLS";
		break;
	case 1:
		strCaption = "um";
		break;
	case 2:
		strCaption = "mm";
		break;
	case 3:
		strCaption = "deg";
		break;
	case 4:
		strCaption = "mrad";
	}
	
	switch(iAxisNumber){
	case 1:
	// Axis 1
		m_strUnit1 = strCaption;
		break;		
	case 2:
	// Axis 2
		m_strUnit2 = strCaption;
		break;
	}
	UpdateData(FALSE);
}

BOOL CDS102Dlg::GetPosition(int iAxisNumber){
//
// W𓾂
//
	CString strCommand;		// MbZ[Wp̃obt@
	CString strPosition;	// Mobt@

	strCommand.Format("axi%d:Position?",iAxisNumber);			// W𓾂R}hZbg
	if (Send(strCommand) == FALSE) return FALSE;				// R}h𑗐M
	if (Receive(strCommand) == FALSE) return FALSE;				// bZ[WM
	strPosition = strCommand.Mid(0,strCommand.GetLength()-1);	// f~^ibqj𓾂

	switch(iAxisNumber){
	case 1:
	// Axis 1
		m_dPosition1 = atof(strCommand);
		((CEdit*)GetDlgItem(IDC_POSITION1))->SetWindowText(strPosition);
		break;

	case 2:
	// Axis 2
		m_dPosition2 = atof(strCommand);
		((CEdit*)GetDlgItem(IDC_POSITION2))->SetWindowText(strPosition);
		break;
	}
	return TRUE;
}

BOOL CDS102Dlg::GetFSpeed(int iAxisNumber){
//
// 쓮x𓾂
//
	CString strCommand;	// bZ[Wp̃obt@

	strCommand.Format("FSpeed%d?",iAxisNumber);		// 쓮x𓾂R}hZbg
	if (Send(strCommand) == FALSE) return FALSE;	// R}h𑗐M
	if (Receive(strCommand) == FALSE) return FALSE;	// bZ[W𓾂
	iFSpeed[iAxisNumber-1] = atoi(strCommand);		// bZ[W𐔒lɕϊ

	switch(iAxisNumber){							// xoϐɓ
	case 1:
		m_uiSpeed1 = iFSpeed[0];					
		break;
	case 2:
		m_uiSpeed2 = iFSpeed[1];
		break;
	}
	UpdateData(FALSE);								// ʂXV
	return TRUE;
}

void CDS102Dlg::OnEmg() 
{
	//
	// ~{^̏
	//
	Send("stop 0");	// Sً}~R}h𑗐M
	CheckStop(0);	// S̒~҂ 
	GetPosition(1);	// P̍WXV
	GetPosition(2);	// Q̍WXV
	GetStatus1(1);	// P̃Xe[^XXV
	GetStatus1(2);	// Q̃Xe[^XXV
	UpdateData(FALSE);	// ʂXV
}

BOOL CDS102Dlg::CheckStop(int iAxisNumber){
//
// w肵~܂őҋ@
//
// iAxisNumberȌꍇ͑S~mF
//
	CString strMessage;
	int iMotion;

	if(iAxisNumber == 0) iAxisNumber = 255;							// S̒~mFꍇAʂWrbgSĂnmɂ
	else				 iAxisNumber = int(pow(2, iAxisNumber-1));	// P̒~mFsꍇAw莲ɑΉrbgnmɂ
	while(1){
		if (Send("Motionall?") == FALSE) return FALSE;	// S̓Xe[^XvR}h𑗐M
		if (Receive(strMessage) == FALSE) return FALSE;	// bZ[WM
		iMotion = atoi(strMessage);						// bZ[W𐔒lɕϊ
		if ((iMotion & iAxisNumber) == FALSE) break;	// bZ[WƎw莲Ƃ̂`mcAOȂ烋[v𔲂
		CheckMessage();									// Windows̃bZ[W
		Sleep(20);										// 20msҋ@
	}
	return TRUE;
}

void CDS102Dlg::OnClear1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	Send("Axi1:Position 0");	// |WVONAR}h𑗐M
	m_dPosition1 = 0.;			// |WVOɂ
	UpdateData(FALSE);			// ʂXV
}

void CDS102Dlg::OnClear2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	Send("Axi2:Position 0");	// |WVONAR}h𑗐M
	m_dPosition2 = 0.;			// |WVOɂ
	UpdateData(FALSE);			// ʂXV
}

BOOL CDS102Dlg::GetStatus1(int iAxisNumber){
//
// Xe[^XP擾
//
	CString strCommand;

	strCommand.Format("Axi%d:sb1?",iAxisNumber);	// Xe[^XPvR}hZbg
	if (Send(strCommand) == FALSE) return FALSE;	// R}h𑗐M
	if (Receive(strCommand) == FALSE) return FALSE;	// bZ[WM
	iStatus1[iAxisNumber-1] = atoi(strCommand);		// Xe[^XPXV
	return TRUE;
}

BOOL CDS102Dlg::GetStatus2(int iAxisNumber){
//
// Xe[^X2擾
//
	CString strCommand;

	strCommand.Format("Axi%d:sb2?",iAxisNumber);	// Xe[^XQvR}hZbg
	if (Send(strCommand) == FALSE) return FALSE;	// R}h𑗐M
	if (Receive(strCommand) == FALSE) return FALSE;	// bZ[WM
	iStatus2[iAxisNumber-1] = atoi(strCommand);		// Xe[^XQXV
	return TRUE;
}

BOOL CDS102Dlg::GetStatus3(int iAxisNumber){
//
// Xe[^XR擾
//
	CString strCommand;

	strCommand.Format("Axi%d:sb3?",iAxisNumber);	// Xe[^XRvR}hZbg
	if (Send(strCommand) == FALSE) return FALSE;	// R}h𑗐M
	if (Receive(strCommand) == FALSE) return FALSE;	// bZ[WM
	iStatus3[iAxisNumber-1] = atoi(strCommand);		// Xe[^XRXV
	return TRUE;
}


void CDS102Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	GetStatus1(1);								// P̃Xe[^X𓾂
	if (iStatus1[0] & MLIMIT) GetStatus2(1);	// ~bgmĂꍇAXe[^XQ𓾂

	GetStatus1(2);								// Q̃Xe[^X𓾂
	if (iStatus1[1] & MLIMIT) GetStatus2(2);	// ~bgmĂꍇAXe[^XQ𓾂

	UpdateStatus();								// Xe[^Xʏɔf
	if ((iStatus1[0] & MOVING) == FALSE) iTimer = iTimer & 0x0fe;	// P쒆łȂꍇAiTimer̃rbgPItɂ
	if ((iStatus1[1] & MOVING) == FALSE) iTimer = iTimer & 0x0fd;	// Q쒆łȂꍇAiTimer̃rbgQItɂ

	if (iTimer == 0) {							// SĂ̎~ĂꍇA^C}~߂
		KillTimer(nIDEvent);
	}

	GetPosition(1);								// P̍WXV
	GetPosition(2);								// Q̍WXV

	if (nIDEvent == 0) return;					// ^C}荞݂Ă΂ĂȂꍇCDialog::OnTimer()

	CDialog::OnTimer(nIDEvent);
}

void CDS102Dlg::UpdateStatus(){
//
// ~bgXe[^Xʂɔf
// 
	((CButton*)GetDlgItem(IDC_CW1 ))->EnableWindow(!( ((iStatus2[0] & CWML) == CWML) & ((iStatus1[0] & MLIMIT) == MLIMIT) ));
	((CButton*)GetDlgItem(IDC_CW2 ))->EnableWindow(!( ((iStatus2[1] & CWML) == CWML) & ((iStatus1[1] & MLIMIT) == MLIMIT) ));
	((CButton*)GetDlgItem(IDC_CCW1))->EnableWindow(!( ((iStatus2[0] & CCWML) == CCWML) & ((iStatus1[0] & MLIMIT) == MLIMIT) ));
	((CButton*)GetDlgItem(IDC_CCW2))->EnableWindow(!( ((iStatus2[1] & CCWML) == CCWML) & ((iStatus1[1] & MLIMIT) == MLIMIT) ));
}

void CDS102Dlg::CheckMessage(){
//
// Windows̃bZ[W
//
    MSG msg;
    if(::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) != 0){
        ::TranslateMessage(&msg);
        ::DispatchMessage(&msg);
    }
}

void CDS102Dlg::OnEnd() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	OnCancel();

}

