// SetupDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "DS102.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg _CAO


CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_iLSpeed = 0;
	m_iRate = 0;
	m_dResolution = 0.0;
	//}}AFX_DATA_INIT
}


void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_Control(pDX, IDC_ORG, m_cmbORG);
	DDX_Control(pDX, IDC_UNIT, m_cmbUnit);
	DDX_Text(pDX, IDC_LSPEED, m_iLSpeed);
	DDV_MinMaxInt(pDX, m_iLSpeed, 1, 9999);
	DDX_Text(pDX, IDC_RATE, m_iRate);
	DDV_MinMaxInt(pDX, m_iRate, 1, 9999);
	DDX_Text(pDX, IDC_RESOLUTION, m_dResolution);
	DDV_MinMaxDouble(pDX, m_dResolution, 1.e-007, 99999999.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg bZ[W nh

BOOL CSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	CString strMessage;
	pMain = (CDS102Dlg*)AfxGetMainWnd();				// eEBhEւ̃|C^𓾂

	//@xikj𓾂
	strMessage.Format("LSpeed%d?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_iLSpeed = atoi(strMessage);
	
	// [giqj𓾂
	strMessage.Format("Rate%d?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_iRate = atoi(strMessage);

	// XCb`Oi_Aj𓾂
	strMessage.Format("Axi%d:memsw0?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_cmbORG.SetCurSel(atoi(strMessage));

	// tmhsi\Pʁj𓾂
	strMessage.Format("Axi%d:Unit?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_cmbUnit.SetCurSel(atoi(strMessage));

	// {\𓾂
	strMessage.Format("axi%d:standard?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	m_dResolution = atof(strMessage);

	// XCb`Pi@B~bg͘_j𓾂
	strMessage.Format("axi%d:memsw1?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_LSNC))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_LSNO))->SetCheck(1);

	// XCb`Qi_ZT͘_j𓾂
	strMessage.Format("axi%d:memsw2?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_ONC))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_ONO))->SetCheck(1);

	// XCb`Riߐڌ_ZT͘_j𓾂
	strMessage.Format("axi%d:memsw3?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_NONC))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_NONO))->SetCheck(1);

	// XCb`SiJg_Ej𓾂
	strMessage.Format("axi%d:memsw4?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_CDON))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_CDOFF))->SetCheck(1);

	// XCb`Tij𓾂
	strMessage.Format("axi%d:memsw5?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_PULS))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_MINUS))->SetCheck(1);

	// }CNXebv𓾂iDS102DS112V[YłP^Qɐݒ肷ꍇ̓R{{bNXɕύXĂj
	strMessage.Format("axi%d:drdiv?",iAxisNumber);
	pMain->Send(strMessage);
	pMain->Receive(strMessage);
	if (atoi(strMessage) == 0) ((CButton*)GetDlgItem(IDC_FULL))->SetCheck(1);
	else					   ((CButton*)GetDlgItem(IDC_HALF))->SetCheck(1);

	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSetupDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	
	if (UpdateData(TRUE) == FALSE) return;

	CString strMessage;
	
	// xݒ肷
	strMessage.Format("lspeed%d %d",iAxisNumber,m_iLSpeed);
	pMain->Send(strMessage);
	
	// [gݒ肷
	strMessage.Format("rate%d %d",iAxisNumber,m_iRate);
	pMain->Send(strMessage);

	// XCb`Oi_Ajݒ肷
	strMessage.Format("Axi%d:memsw0 %d",iAxisNumber,m_cmbORG.GetCurSel());
	pMain->Send(strMessage);

	// tmhsi\P)ݒ肷
	strMessage.Format("Axi%d:unit %d",iAxisNumber,m_cmbUnit.GetCurSel());
	pMain->Send(strMessage);

	// {\ݒ肷
	strMessage.Format("Axi%d:standard %9f",iAxisNumber,m_dResolution);
	pMain->Send(strMessage);

	// XCb`Pi@B~bg͘_jݒ肷
	strMessage.Format("Axi%d:memsw1 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_LSNO))->GetCheck());
	pMain->Send(strMessage);

	// XCb`Qi_ZT͘_jݒ肷
	strMessage.Format("Axi%d:memsw2 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_ONO))->GetCheck());
	pMain->Send(strMessage);

	// XCb`Riߐڌ_ZT͘_jݒ肷
	strMessage.Format("Axi%d:memsw3 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_NONO))->GetCheck());
	pMain->Send(strMessage);

	// XCb`SiJg_Ejݒ肷
	strMessage.Format("Axi%d:memsw4 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_CDOFF))->GetCheck());
	pMain->Send(strMessage);

	// XCb`Tijݒ肷
	strMessage.Format("Axi%d:memsw5 %d",iAxisNumber,((CButton*)GetDlgItem(IDC_MINUS))->GetCheck());
	pMain->Send(strMessage);

	// }CNXebvݒ肷cQQOV[YłP^Qɐݒ肷ꍇ̓R{{bNXɕύXĂj
	strMessage.Format("Axi%d:drdiv %d",iAxisNumber,((CButton*)GetDlgItem(IDC_HALF))->GetCheck());	
	pMain->Send(strMessage);

	CDialog::OnOK();
}

void CSetupDlg::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	
	CDialog::OnCancel();
}
